"use strict"

const uuid = require('node-uuid')

module.exports = function(requestIdHeader){

    const REQUEST_ID_HEADER = (requestIdHeader || '').toString().trim() || 'X-Request-ID'

    return function(req, res, next) {
        // get value from header, defaulting to new uuid if not found
        var header = req.header(REQUEST_ID_HEADER, uuid.v4())

        // set value into response header
        res.header(REQUEST_ID_HEADER, header)

        next()
    };
}